// $Id: SimpleDebuggable.hh 8352 2008-11-12 18:39:08Z m9710797 $

#ifndef SIMPLEDEBUGGABLE_HH
#define SIMPLEDEBUGGABLE_HH

#include "Debuggable.hh"
#include "EmuTime.hh"

namespace openmsx {

class MSXMotherBoard;

class SimpleDebuggable : public Debuggable
{
public:
	SimpleDebuggable(MSXMotherBoard& motherBoard, const std::string& name,
	                 const std::string& description, unsigned size);
	virtual ~SimpleDebuggable();

	virtual unsigned getSize() const;
	virtual const std::string& getName() const;
	virtual const std::string& getDescription() const;

	virtual byte read(unsigned address);
	virtual byte read(unsigned address, EmuTime::param time);
	virtual void write(unsigned address, byte value);
	virtual void write(unsigned address, byte value, EmuTime::param time);

private:
	MSXMotherBoard& motherBoard;
	const std::string name;
	const std::string description;
	const unsigned size;
};

} // namespace openmsx

#endif
